/*
 * main.c
 *
 * Created: 23.09.2019 
 * 
 *
 * Es wird mit einem Atmel ATMega88
 *
 */

// #define TEST 1

#include "iom88.h"
#include "main.h"
//#include <stdint.h>

  int Test_Drehzahl_low;       //For testing only!!
  int Test_Drehzahl_1;       //For testing only!!
  int Test_Drehzahl_2;       //For testing only!!
  int Test_Value_Timer_2;       //For testing only!!

int main(void)
{
  #ifdef TEST
    signed int i;
  #endif	  
  
  // 1 rpm    ->    1000 / 60 = 16,6 Impulse/s  -> 1000 / 16,6 = 60,25 ms/Impuls
  // 10 rpm   ->   10000 / 60 = 166  Impulse/s  -> 1000 / 166  = 6,025 ms/Impuls 
  // 120 rpm  ->  120000 / 60 = 2000 Impulse/s  -> 1000 / 2000 = 0,5   ms/Impuls
  // 2000 rpm -> 2000000 / 60 = 33333 Impulse/s -> 1000 / 33333 = 0,03 ms/Impuls
  // 8 Mhz -> 0,125 us / Takt
  // Timer1 CLK/8 -> 1 us / Timertakt -> 65535 * 1 us = 62 ms -> ~ 1 rpm
  // Wenn Impuls schneller als 0,5 ms dann 10 Imulse messen mit
  // Timer1 CLK/1 -> 0,125 us / Timertakt -> 65535 * 0,125 us = 8192 us = 8 ms 
  // 120 rpm  ->  120000 / 60 = 2000 Impulse/s  -> 10 Impulse = 5 ms -> 5000 us / 0,125 us = 40000 Timerticks
  // 2000 rpm -> 2000000 / 60 = 33333 Impulse/s -> 10 Impulse = 0,3 ms -> 300 us / 0,125 us = 2400 Timerticks
  	
  PORTB = 0x00;           // No Pullups
  DDRB = 0x03;            // PORTB_Bit0 = 1k3, Bit1 = 0R

  PORTC = 0; 
  DDRC = 0x1F;            // Out_0-4 Ausgaenge 47k, 22k, 11k, 5k6, 2k7

  PORTD = 0x20;           // Pull-Up T1 (Bit5)
  DDRD = 0x00;                                
  
  ACSR = 0x80;            // Disable Analog Comparator 
  DIDR1 = 0x03;           // Disable input register on AIN0/AIN1
  ADCSRA = 0xC7;          // Clock / 128 langsamer geht nicht, kein INT  
  ADMUX = 0xC5;           // Int 1,1V Ref, ADC5
  DIDR0 = 0x20;           // Disable input register on ADC5
  
  TCCR0A = 0x02;          // T0 CRC mode 
  TCCR0B = 0x06;          // T0 External clock source on falling edge 
  OCR0A = 1;              // CRC int after 1 clocktick
  TIMSK0 = 0x02;          // Timer 0 Compare match A int

  TCCR1A = 0x00;          // T1 normal mode 
  TCCR1B = 0x02;          // clk/8 source on T1
  TIMSK1 = 0x01;          // Timer 1 Overflow int  
  Value_TCCR1B = TCCR1B;
  Value_Timer1 = 60000;
  
  Min_Timer1 = 60000;
  Max_Timer1 = 0; 
  Counter_Timer1 = 0;
  
  Test_Drehzahl_1 = 0;       //For testing only!!
  Test_Drehzahl_2 = 0;       //For testing only!!
  Test_Drehzahl_low = 0;       //For testing only!!
  
  EAL = 1;   
    
  while(1)
  { 
    if (TCCR1B == 0x02) {
      if (Value_Timer1 <= 500) {   // < 0,5 ms / Impuls
        OCR0A = 8;                 // CRC int after 8 clocktick  
        TCNT0 = 0;                // Reset timer 0 value
        TCCR1B = 0;               // stop T1
        TCNT1 = 0;                // Reset timer 1 value
        TCCR1B = 1;               // clk/1 source on T1
        Value_TCCR1B = TCCR1B;
      }  
    } else {    
      if (Value_Timer1 > 40000) {  // > 0,5 ms / 10 Impulse     //Langsam Mode
        OCR0A = 1;                // CRC int after 1 clocktick  
        TCNT0 = 0;                // Reset timer 0 value
        TCCR1B = 0;               // stop T1
        TCNT1 = 0x1FF;
        TCCR1B = 2;               // clk/8 source on T1
        Value_TCCR1B = TCCR1B;
      }  
    } 
    
    if (Counter_Timer1 > 2) {
     if (Value_Timer1 < Min_Timer1) {
        Min_Timer1 = Value_Timer1;
      }
      if (Value_Timer1 > Max_Timer1) {
        Max_Timer1 = Value_Timer1;
      }
      if (Counter_Timer1 > 1000) { 
        Counter_Timer1 = 0;
        Min_Timer1 = 60000;
        Max_Timer1 = 0;
      }
    }     

    if (TCCR1B == 0x02) 
    {                      
      //Drehzahl = 60000 / (Value_Timer1 / 10); // 0,1 UPM,  bei 60000 uS -> 1 UPM
      
      Test_Value_Timer_2 = (Value_Timer1/10);         //For testing
      Drehzahl = (60000/Test_Value_Timer_2); // 0,1 UPM,  bei 60000 uS -> 1 UPM
      Test_Drehzahl_low = Drehzahl;
    } 
    else 
    { 
      if (Value_Timer1 > 10000)
      {
        //Drehzahl = 48000 / (Value_Timer1 / 100); // 1 UPM,  bei 5000 uS -> 120 UPM
        
        Test_Value_Timer_2 = (Value_Timer1/100);      //For Testing
        Drehzahl = (48000/Test_Value_Timer_2); // 1 UPM,  bei 5000 uS -> 120 UPM
        Test_Drehzahl_1 = Drehzahl;           //For testing only!!
      } 
      else 
      { 
        //Drehzahl = 48000 / (Value_Timer1 / 10);  // 1 UPM,  bei 5000 uS -> 120 UPM  ... 120UPM????
        //Drehzahl *= 10;
        
        Test_Value_Timer_2 = (Value_Timer1/10);         //For testing
        Drehzahl = (48000/Test_Value_Timer_2);  // 1 UPM,  bei 5000 uS -> 120 UPM 
        Drehzahl *= 10;
        Test_Drehzahl_2 = Drehzahl;       //For testing only!!
      }  
    }
        
    #ifdef TEST
      while (i > 0) {
        i = i - 1;
	      if (i < 3000) {
        }
      }
	  #endif  
  }
}

#pragma vector=INT0_vect

__interrupt void INT0_int(void)    
{
}

#pragma vector=INT1_vect

__interrupt void INT1_int(void)    
{
}

#pragma vector=TIMER0_COMPA_vect

__interrupt void TIMER0_COMPA_int(void) 
{
  TCCR1B = 0;                   // Timer1 Stop
  Value_Timer1 = TCNT1;
  TCNT1 = 0;                    // Reset timer 1 value
  TCCR1B = Value_TCCR1B;  
  Counter_Timer1++;   
  Counter_Int = 1;
}

#pragma vector=TIMER1_OVF_vect

__interrupt void TIMER1_OVF_int(void) 
{
  if (Value_TCCR1B == 2)        // Drehzahl < 1,0 UPM                   For testing only
  {      
    Drehzahl = 0;
  } 
  else 
  {
    //Timer1_OVF++;
  }

/*if (Value_TCCR1B == 2)                  // Drehzahl < 1,0 UPM         For testing only
  {      
    Drehzahl = 0;
  } 
 */
 
  
  // if (Timer1_OVF == 2) {      // Drehzahl < 1,0 UPM
 //   Drehzahl = 0;
 /* } else {
    Timer1_OVF++;
  }
*/
}  
  
